/*************************************
labellingを行う。標準プログラムのlabelling.cを変更。

2014/12/03 by K.Mano and Y.Igarashi
****************************************/



#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>
#include "header/col_define.h"

int color_labelling(IplImage *src/*入力画像*/, CvRect *rectmax/*ボールとして認識した領域の情報*/){

	int label_num=0;
	int cntr_num;
	int i, j;	//ループ用変数
	int x1[200], y1[200], x2[200], y2[200], width[200], height[200];


	CvMemStorage *storage = cvCreateMemStorage(0);
	CvSeq *contour = NULL;
	CvRect rect[200];	//四角形領域の情報構造体((左上).x, (左上).y, .height, .width)
	CvPoint point1[200], point2[200];
	IplImage *src2;


	//src2= cvCreateImage(cvGetSize(src), IPL_DEPTH_8U, src->nChannels);
	//src2= cvCreateImage(cvGetSize(src), IPL_DEPTH_8U, 1);
	src2 = cvLoadImage("./img/gaus.jpg", CV_LOAD_IMAGE_ANYCOLOR);	
	
	//cvCopyImage(src, src2);


	// エリアの抽出条件
	/* 320x240 pixel の画像を50cm の距離で撮影した場合
	   1以外の数字   width = 60 ,  height = 106 
	   1の場合       widht = 13 ,  height = 106 
	   widht_min = 10, widht_max = 80, height_min = 90, height_min = 120
	*/

	int width_min, width_max, height_min, height_max;
	float mag ; // 320x240pixel, 50cm を基準とした、拡大（縮小）率
	mag = 1;
	//mag = 2 * 50. /150. ; 640x480pixel, 150cm の場合 整数演算にしない、1/3倍される

	//縦横の最小、最大を決めている
	width_min = 20*mag;		width_max =80*mag; 
	height_min = 20*mag;	height_max =120*mag; 

	printf("width_min=%d, width_max=%d, height_min=%d, height_max=%d\n", width_min, width_max, height_min, height_max);

	
	//画像入力に失敗なら関数終了
	if(src == NULL) return;

	//輪郭検出(戻り値は取得した輪郭の全個数)
	cntr_num = cvFindContours(src, storage, &contour, sizeof(CvContour), CV_RETR_EXTERNAL, CV_CHAIN_APPROX_SIMPLE, cvPoint(0,0));
	#ifdef __DEBUG__
		printf("抽出した輪郭の個数=%d\n",cntr_num);
	#endif
	for(i = 0; i < cntr_num; i++){
/*		x1[i] = 1;
		y1[i] = 1;
		x2[i] = 1;
		y2[i] = 1;
		height[i] = 0;
		width[i] = 0;
	}

	for(i = 0; i < cntr_num; i++){	//輪郭の傾いていない外接四角形領域の座標を取得
*/		rect[i] = cvBoundingRect(contour, 1);
		x1[i] = rect[i].x;
		y1[i] = rect[i].y;
		x2[i] = rect[i].x + rect[i].width;
		y2[i] = rect[i].y + rect[i].height;
		height[i] = rect[i].height;
		width[i] = rect[i].width;
	#ifdef __DEBUG__
		printf("エリア番号=%d   エリアの幅=%d    エリアの高さ=%d\n",i,width[i],height[i]);
	#endif
		//四角形の描画(src2に描画、左上x1,y1、右下x2,y2の四角形)
		cvRectangle(src2, cvPoint(x1[i], y1[i]), cvPoint(x2[i], y2[i]), CV_RGB(255, 255, 255), 1, 8, 0);

		//一番でかいのとる。label_numに一番大きいrect(四角形領域の情報)の番号
		if(width[i]*height[i]>width[label_num]*height[label_num]){
			label_num = i;
		}
		
		contour = contour->h_next;
	}

	/**/
	printf("label_num=%d\n",label_num);

		//四角形の描画	
		cvRectangle(src, cvPoint(x1[label_num], y1[label_num]), cvPoint(x2[label_num], y2[label_num]), CV_RGB(255, 255, 255), 1, 8, 0);
		
		if(label_num==0){
			rect[0].x=-1;
			rect[0].y=-1;
			
		}
		//一番大きいrectを返す
		*rectmax = rect[label_num];
		
	//画像の保存
	cvSaveImage("./img/label-all.jpg", src2, NULL);
	cvSaveImage("./img/label.jpg", src, NULL);


//メモリストレージの解放
	cvReleaseMemStorage (&storage);

	cvReleaseImage(&src2);
	return label_num;
}

