#ifndef HARDWARE_H_
#define HARDWARE_H_

//ロータリエンコーダの更新周期 [ms]
#define T_ENCODER 20 

//モータ速度制御の制御周期 [ms]
#define T_VEL_CTRL 20 

//走行制御のの更新周期 [ms]
#define T_RUN_CTRL 20 

//ディフォルトの制御周期 [ms]
#define T_CTRL 20 

//テストプログラムの結果確認周期 [ms]
#define T_TEST 20 

// for STANDARD MIRS
// タイヤ半径 [cm]
#define TIRE_R 2.4 

// タイヤ間距離 [cm]
#define BETWEEN_TIRE 34.0 
// 機体の中心からタイヤまでの距離 [cm]
#define DISTANCE_TIRE 17.0 

// タイヤの回転方向を機体全体で反時計回りを正とする補正
#define TIRE_DIRECTION -1 

//右タイヤを１とした場合の左タイヤの走行距離補正値
//#define TIRE_DIST_RATIO  1.00
#define TIRE_DIST_RATIO  1.0375

#define TIRE_DIST_RATIO_B  1.0

//エンコーダ [パルス/周] ４倍時 360x4 = 1440
#define ENC_PPS  1440 
//encoder _
#define ENC_L 1.10
#define ENC_B 0.96

// モータとエンコーダの回転比率 = モータ軸直径/エンコーダプーリ直径
#define M_E_RATIO 0.6875
//エンコーダプーリ直径＞1.6cm 
//プーリもどき（レゴ）＞円周3.3cm 直径＞1.05
// モータとエンコーダの回転比率 プーリーの違い用
#define M_E_RATIO_B 1.0474

// カメラと正面USS先端の距離差
#define CAM_USS_DIF 2

#endif
