// MIRSAK パトロール走行
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include "./../mirsak.h"
//#include "patrol_sequence.h"
#include "./../../hardware.h"
#include "./../../direction/direction.h"
#include "./../../run/run_ctrl.h"
#include "./../../gazou/number/extern.h"
#include "./../../gazou/header/col_extern.h"//怪盗認識
#include "./../../device/io.h"
#include "./../../device/lamp.h"
#include "./../../device/needle.h"
#include "./../../device/uss.h"
#include "./../../run/distance.h"
#include "./../../server/server_info.h"

#define USS_FR 1
#define USS_FL 3
#define USS_RF 4
#define USS_RR 2

int destroy(int front_or_rear){
	const float default_speed = 40.0; //直進速度[cm/sec] 
	const float default_speed_rot = 20.0; //回転速度 [deg/sec]


	//数字ボードまでの距離 = 正体補正距離 - (カメラとUSS先端の距離差）正対補正とわける。

//	int num_distance = 50; // CAM_DIF ; //MIRS先端からカメラの距離、先端の距離と合わせる



/*************************************************/
	float x=0.3;
	int y=100;
	int color_x,color_y,color_length;
	int dir=0;	//後ろ(-1)か前(1)か
	int uss[5]={0,0,0,0,0};
	int i;
	int destroy_end_flag=0;


	struct distance_data curr_dis_data;
	struct distance_data destroy_start_dis_data;

	distance_sum_get(&destroy_start_dis_data);

	// rear or front. dir times y.
	if(front_or_rear==FRONT){
		dir=1;
	}else{
		dir=-1;
	}



	//number_set_nums(1); //ボード上の数字の数を1にセット


	color_detect(front_or_rear,&color_x,&color_y,&color_length);

	x = x * (color_x - 320);

	//自己位置にもよるが針を展開する
	//needle_create(ON);
	//カメラスレッド前方後方のどちらか
	run_ctrl_reset();
	run_ctrl_set_speed(default_speed);
	run_ctrl_set_xy_dist(x, dir*y);	
	run_ctrl_create();				//走行のスレッド生成
	printf("run ctrl create\n");



	while(1){
		//動作開始
		//怪盗との距離、ズレ、移動方向、自己位置から移動先を決定
		//小部屋の時はさらに特殊動作へ
		//怪盗を見失ったら
		//break;

		x=1;
		y=100;

		//超音波センサの読み込み read sonic sensor
		uss[USS_FR] = uss_get(USS_FR);
		uss[USS_FL] = uss_get(USS_FL);
		uss[USS_RF] = uss_get(USS_RF);
		uss[USS_RR] = uss_get(USS_RR);
		for(i=1;i<5;i++) printf("uss%d=%d\n",i,uss[i]);

		//read enemy
		color_detect(front_or_rear,&color_x,&color_y,&color_length);

		//limit of wall
		//go dir front wall 進行方向の壁の認識
		if(color_x == -1){
			//Can't enemy detect
			//go to center
 			distance_sum_get(&curr_dis_data);
			x = destroy_start_dis_data.x_dist - curr_dis_data.x_dist;
			y = destroy_start_dis_data.y_dist - curr_dis_data.y_dist;
			if (x<5 && x>-5 && y<5 && y>-5){
				printf("Here is center.\n");
				while(1){	
					if(run_ctrl_get_endflag()==1){	
						run_ctrl_cancel();
					}
				}
				destroy_end_flag = 1;
			}

			//wall
			switch(front_or_rear){
			case FRONT:
				if(uss[USS_FR] < 50 && uss[USS_FL] < 50) y=-100;
				break;
			case REAR:
				if(uss[USS_RR] > 100) y=-100;
				break;
			}

		}else{
			//Enemy detect
			x = x * (color_x - 320);
		}

		//limit of wall
		//go dir right wall
		if(uss[USS_RF]>84){
			if(uss[USS_RF]!=9999){//壁が測定不能なほどに遠くなかったら
				x=20;	//壁から遠ざかる
			}
		}else if(uss[USS_RF]<30){	//nearly wall
			x=-20;
		}else{
			x = x * (color_x - 320);
		}
		printf("x=%d,y=%d\n",x,y);
		run_ctrl_set_xy_dist(x, dir*y);

		//run_ctrlスレッドが終わったら新しく立てる
		if(run_ctrl_get_endflag()==1){
			run_ctrl_cancel();
			run_ctrl_reset();	
			run_ctrl_set_speed(default_speed);
			run_ctrl_set_xy_dist(x, y);	
			run_ctrl_create();		
		}

		if(destroy_end_flag==1) break;

		usleep(1000*10);

	}
//怪盗確報の情報があるか
//if()
	run_ctrl_set_xy_dist(0., 0.);
	run_ctrl_reset();
	run_ctrl_cancel();
	return server_info_capture();//確保したら終了

//中央へ戻る
//移動
	//needle(OFF);

//索敵へ戻る

	run_ctrl_stop();
	usleep(100*1000);

}


