//全体の制御を行う
//main
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include "mirsak.h"
#include "./../device/device.h"
#include "./../device/encoder.h"
#include "./../run/vel_ctrl.h"
#include "./../device/io.h"
#include "./../server/server_info.h"
#include "./../map/map.h"

int main(){

	int ret_val;
	int dir;
	//デバイスオープン
	ret_val=device_encoder_open();
	ret_val=device_motor_open();
	ret_val=device_uss_open();
	ret_val=device_io_open();
	ret_val=device_lamp_open();
	ret_val=device_needle_open();
	//エンコーダ、速度制御スレッドの生成
	encoder_create(); 
 	vel_ctrl_create();
	map_create();
	server_info_init();//送受信データファイルの初期化

	patrol(); //巡回走行
	ret_val=0;
	while(1){
		dir = search(); //索敵 返り血は発見したカメラの向き
		//どちらのカメラで追跡するか
		if(dir != -1){
			ret_val = destroy(dir);//追跡、破壊 返り血は怪盗確保か見失ったか
		}else{
			ret_val = destroy_room(dir);//追跡、破壊 返り血は怪盗確保か見失ったか
		}

		if(ret_val == 1){//終了
			break;
		}
	}
	//デバイスのクローズ
	device_encoder_close();
	device_motor_close();
	device_uss_close();
	device_io_close();
	device_lamp_close();
	device_needle_close();
	return 0;

}

