// MIRSAK パトロール走行
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

#include "./../mirsak.h"
//#include "patrol_sequence.h"
#include "./../../hardware.h"
#//include "./../../run/direction.h"
#include "./../../run/distance.h"
#include "./../../run/run_ctrl.h"
#include "./../../run/vel_ctrl.h"
//#include "./../../gazou/number.h"
//#include "./../../gazou/extern.h"//怪盗認識
#include "./../../device/io.h"
#include "./../../device/lamp.h"
#include "./../../device/needle.h"

#include<math.h>

#define __DEBUG__

void run_correct(int);


void run(float speed,float x,float y){
	char io_mdata[12];
	int i;//ループ用変数
	int rerun_flag=0;
	int to_sum=0;
	struct distance_data now_dis;	

	run_ctrl_reset();
	run_ctrl_set_speed(speed);
	run_ctrl_set_xy_dist(x, y);	
	run_ctrl_create();				//走行のスレッド生成

	io_get(io_mdata);

	while(1){	//タッチセンサがはなれるまでループ
		to_sum=0;
		io_get(io_mdata);
		for(i=0;i<9;i++){
			io_mdata[i] -= 49;	//m_dataにはアスキーコードとして"1"が入ってる
			to_sum += io_mdata[i];
			printf("iodata[%d]=%d\n",i,io_mdata[i]);
		}
		if(to_sum==0) break;
		usleep(200*1000);
	}


	while(1){//run_ctrl終わるまで待機
		io_get(io_mdata);


		
		/*	タッチセンサが反応しているかの検知
			 iに反応したタッチ部分が入る
			2個反応してもタッチ番号が小さい方が入る
		*/
		for(i=0;i<9;i++){
			io_mdata[i] -= 49;
	#ifdef __DEBUG__
		//	printf("TSW%d : %c(askey)\t%d(int)\n",i+1,io_mdata[i],io_mdata[i]);
	#endif
			if(io_mdata[i]==-1){
				rerun_flag=1;
				run_ctrl_cancel();
				vel_ctrl_set(0., 0., 0.);
				break;//while文抜ける
			}
			
		}
		if(rerun_flag) break;
		//タッチセンサが反応してたら					


		if(run_ctrl_get_endflag()==1)	break;
		usleep(20000);
	}
	
	if(rerun_flag != 0){
	distance_get(&now_dis);
	run_correct(i);			
	
	
		printf("\nrerun dist_x=%lf\trerun dist_y=%lf\n",x-now_dis.x_dist,y-now_dis.y_dist);
		run(speed,x-now_dis.x_dist,y-now_dis.y_dist);
		//run(speed,x,y);
	}
}





void run_correct(int touch){
#ifdef	__DEBUG__
		printf("タッチセンサ%dが反応\n",touch+1);
#endif


	switch(touch+1){
	case 1:
	run_ctrl_reset();
	run_ctrl_set_speed(10);
	run_ctrl_set_xy_dist(4.3, 2.5);	
	run_ctrl_create();
		//run(10,4.3,2.5);
		break;
	case 2:
	run_ctrl_reset();
	run_ctrl_set_speed(10);
	run_ctrl_set_xy_dist(1, -4.9);	
	run_ctrl_create();
		//run(10,1,-4.9);
		break;
	case 3:
	run_ctrl_reset();
	run_ctrl_set_speed(10);
	run_ctrl_set_xy_dist(-1, 4.9);	
	run_ctrl_create();
//		run(10,-1,4.9);
		break;
	case 4://
	run_ctrl_reset();
	run_ctrl_set_speed(10);
	run_ctrl_set_xy_dist(-4.3, 2.5);	
	run_ctrl_create();
		//run(10,-4.3,2.5);
		break;
	case 5://
	run_ctrl_reset();
	run_ctrl_set_speed(10);
	run_ctrl_set_xy_dist(-4.9, -1);	
	run_ctrl_create();
		//run(10,-4.9,-1);
		break;
	case 6://]
	run_ctrl_reset();
	run_ctrl_set_speed(10);
	run_ctrl_set_xy_dist(-1.7, -4.7);	
	run_ctrl_create();
		//run(10,-1.7,-4.7);
		break;
	case 7://FRONT
	run_ctrl_reset();
	run_ctrl_set_speed(10);
	run_ctrl_set_xy_dist(0, -5);	
	run_ctrl_create();
	//	run(10,0,-5);
		break;
	case 8://
	run_ctrl_reset();
	run_ctrl_set_speed(10);
	run_ctrl_set_xy_dist(1.7, -4.7);	
	run_ctrl_create();
		//run(10,1.7,-4.7);
		break;
	case 9://
	run_ctrl_reset();
	run_ctrl_set_speed(10);
	run_ctrl_set_xy_dist(1.7, -4.7);	
	run_ctrl_create();
		//run(10,1.7,-4.7);
		break;

	default: printf("タッチセンサ%d番てどこ??\n",touch);
	}
	while(1){
		if(run_ctrl_get_endflag()==1)	break;
		usleep(20000);
	}
	
}


