/*

 サーバから送られてくる情報をチェックする。
 void server_info_init()  サーバから送られて来るファイルを消去する
 int server_info_invade() 怪盗が競技場に侵入したをチェックする 
 int server_info_capture() 怪盗が確保された（風船が割られたか）をチェックする
 int server_info_thief()   怪盗が宝を運び出そうとしている部屋番号を知る

 2014/12/5 coded  by S.Ushimaru

*/

#include <stdio.h>
#include <sys/stat.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

static int num;

static int check_time(int *sec, int *min, int *hour);
static int check_num();

/*
サーバ情報の初期化
サーバから送られて来るファイルを消去する
*/
void server_info_init(){

	system("rm -f ./info/info_thief.data");
	system("rm -f ./info/info_invade.data");
	system("rm -f ./info/info_capture.data");
	system("rm -f ./info/info_treasure.data");
/*
	system("rm -f /home/mirs/info/info_thief.data");
	system("rm -f /home/mirs/info/info_invade.data");
	system("rm -f /home/mirs/info/info_capture.data");
	system("rm -f /home/mirs/info/info_treasure.data");
*/
}

/*
 怪盗(thief)が競技場に侵入したをチェックする関数。
 侵入した場合は1を、新入していない場合を -1 を戻す。
 侵入情報はサーバから /home/mirs/server/info_invade.data のファイルとして送られてくる。
*/
int server_info_invade(){

	FILE *fp;
	if((fp=fopen("./info/info_invade.data","r")) == NULL){
	//if((fp=fopen("/home/mirs/info/info_invade.data","r")) == NULL){
		//printf("File can not open!\n");
		return -1;
	}

        fclose(fp);

        return 1;
}


/*
 怪盗(thief)が確保された（風船が割られたか）をチェックする関数。
 確保された場合は1を、確保されていない場合を -1 を戻す。
 侵入情報はサーバから /home/mirs/server/info_capture.data のファイルとして送られてくる。
*/
int server_info_capture(){

	FILE *fp;
	if((fp=fopen("./info/info_capture.data","r")) == NULL){
//	if((fp=fopen("/home/mirs/info/info_capture.data","r")) == NULL){
		//printf("File can not open!\n");
		return -1;
	}

        fclose(fp);

        return 1;
}


/*
 怪盗(thief)が宝(treasure)を運び出そうとしている部屋番号を知るための関数。
 新しい部屋番号情報が送られていた場合は部屋番号を、そうでない場合を -1 を戻す。
 部屋番号の情報はサーバから /home/mirs/info/info_thief.data のファイルとして送られてくる。
*/
int server_info_thief(){

	static long time, prev_time=0;
	int ret;
	int sec, min, hour;

	ret = check_time(&sec, &min, &hour);
	if(ret == -1) return -1;

	time = hour*60*60 + min*60 + sec;
	if(time > prev_time){
		printf("info_thief renewed time =  %d:%d:%d\n",hour,min,sec);
		ret=check_num();
		//printf("num=%d\n",num);
		prev_time = time;
		return num;
	}else{
		return -1;
	}

}

/*
MIRSが確認した宝の番号をサーバに送信する
*/
int server_info_treasure(int num){

        FILE *fp;
        int ret;

/*        fp=fopen("/home/mirs/info/info_treasure.data","a");
        //printf("%d\n",num);
        fprintf(fp,"%d\n",num);
        fclose(fp);
*/
        ret=system("scp /home/mirs/mirs1401/ver_7_2_test/mapping/test.txt PC User@172.21.2.31:~/");
        //printf("ref=%d\n",ret);

        if(ret==0){
                return 0;
        }else{
                return -1;
        }

}


/*
 ファイルの数字をチェックする関数
 ファイルをオープン出来なかったら -1 を返す
*/
static int check_num(){

	char *numc;
	FILE *fp;
	char dumy = '0';

	numc = &dumy;
	if((fp=fopen("./info/info_thief.data","r")) == NULL){
	//if((fp=fopen("/home/mirs/info/info_thief.data","r")) == NULL){
		printf("File can not open!\n");
		return -1;
	}

	*numc = getc(fp);
	num = atoi(numc); //char 型の数字を整数型に変換する
	//printf("num=%d\n",num);

	fclose(fp);

	return 0;
}

/*
 ファイルの更新時間をチェックする関数
 ファイルにアクセス出来なかったら -1 を返す
*/
static int check_time(int *sec, int *min, int *hour){

	struct stat stat_buf;
	struct tm *strtim;
	time_t time;
	int ret;
	ret=stat("./info/info_thief.data",&stat_buf);
	//ret=stat("/home/mirs/info/info_thief.data",&stat_buf);
	//printf("ret=%d\n",ret);
	if(ret == -1){
		return -1;
	}

	time = stat_buf.st_mtime;

	strtim = localtime(&time);
	*sec = strtim->tm_sec;
	*min = strtim->tm_min;
	*hour = strtim->tm_hour;

	return 0;

}

