// タスクの生成・初期化
// 作成日：2013/1/10

#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include "./../device/device.h"
#include "./../hardware.h"
#include "distance.h"
#include "./../device/encoder.h"

static pthread_t tasks[1];
static float dis_coef = 2*3.1415*TIRE_R/ENC_PPS/M_E_RATIO; //for STANDARD MIRS

static void *thread_code(void *t){

	int counter=0;
	struct distance_data distance_data;
	struct encoder_data encoder_data;
	while(1){
		counter++;

		//if(counter > 200) break;

		//distance_get(&distance_l, &distance_r);

		distance_get(&distance_data);//x,y方向の移動距離
		printf("distance_x=%8.3f    distance_y=%8.3f distance_s=%8.3f\n",distance_data.x_dist,distance_data.y_dist,distance_data.shet);
		encoder_get(&encoder_data);//各タイヤの回転量
		printf("distance_r=%8.3f    distance_l=%8.3f distance_b=%8.3f\n",encoder_data.right_sum*dis_coef,encoder_data.left_sum*dis_coef*ENC_L,encoder_data.back_sum*dis_coef*ENC_B);

		usleep((T_TEST-1)*1000);
		//usleep(19000); // 19msec →　スケジューラで20msec weight と等価

	}


	return 0;

}

static int thread_create()
{
	pthread_attr_t attr;
	struct sched_param sched_param;
	int ret;

	pthread_attr_init(&attr);
	sched_param.sched_priority = 5;
	pthread_attr_setschedparam(&attr, &sched_param);
	ret = pthread_create(&tasks[0], &attr, thread_code, (void *)2);

	return 0;
}

void test_distance(){

/*
	int s_val;
	printf("PWM value [right]= ");
	s_val=scanf("%d",&pwm_duty_r);
	printf("PWM value [left]= ");
	s_val=scanf("%d",&pwm_duty_l);
*/

	encoder_create();

	thread_create();
	printf("thread_id=%d\n",(int)tasks[0]);
	pthread_join(tasks[0],NULL);
	printf("Program stopped\n");

}


