// タスクの生成・初期化
// 作成日：2013/1/10

#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include "./../device/device.h"
#include "./../hardware.h"
//#include "mirsak.h"
#include "./../device/encoder.h"
#include "./../device/motor.h"

//static pthread_t tasks[1];
static pthread_t task_id;
static int pwm_duty_r, pwm_duty_l, pwm_duty_b;

unsigned char m_data[3];
static int fd_motor;
//static int fd_encoder;
static float t_coef = 2*3.1415*TIRE_R/ENC_PPS/T_ENCODER*1000/M_E_RATIO; //for STANDARD MIRS

static void *thread_code(void *t){

	FILE *fp;
	int counter=0;
	int ret_val;
	struct encoder_data encoder_data;
	float vel_l, vel_r, vel_b;

	fp=fopen("test.data","w");
	fd_motor=device_motor_get();

	printf("enc_left \t enc_right \t  enc_left_sum \t enc_right_sum\n");

	while(1){
		counter++;

		//if(counter > 200) break;
		
		//ret_val=write(fd_motor,m_data,2);

		//motor_drive(pwm_duty_l, pwm_duty_r);

		m_data[0]=pwm_duty_l;
		m_data[1]=pwm_duty_r;
		m_data[2]=pwm_duty_b;
		ret_val=write(fd_motor,m_data,3);

		//encoder_read(&encoder_data);
		encoder_get(&encoder_data);

		//printf("counter=%5d left=%5d  right=%5d left_sum=%5d right_sum=%5d\n",counter,encoder_data.left,encoder_data.right, encoder_data.left_sum, encoder_data.right_sum);
		printf("left=%5d    right=%5d    left_sum=%5d    right_sum=%5d\n",encoder_data.left,encoder_data.right, encoder_data.left_sum, encoder_data.right_sum);

		vel_l = encoder_data.left * t_coef;
                vel_r = encoder_data.right * t_coef;
                vel_b = encoder_data.back * t_coef;
		printf("vel_l=%5d[cm/s], vel_r=%5d[cm/s],vel_b=%5d[cm/s]\n",(int)vel_l, (int)vel_r, (int)vel_b);


		//usleep(19000); // 19msec →　スケジューラで20msec weight と等価
		//usleep((T_CTRL_VEL -1) *1000 ); // 1ms はスケジューラの精度で遅れる
		usleep((T_TEST-1)*1000);

	}

	
	m_data[0]=0;
	m_data[1]=0;
	m_data[2]=0;

	ret_val=write(fd_motor,m_data,3);
	//motor_drive(0,0);

	fclose(fp);
	return 0;

}

static int thread_create()
{
	pthread_attr_t attr;
	struct sched_param sched_param;
	int ret;

	pthread_attr_init(&attr);
	sched_param.sched_priority = 5;
	pthread_attr_setschedparam(&attr, &sched_param);
	//ret = pthread_create(&tasks[0], &attr, thread_code, (void *)2);
	ret = pthread_create(&task_id, &attr, thread_code, (void *)2);

	return 0;
}

void test_pwm_vel(){

	int s_val;
	printf("PWM value [right]= ");
	s_val=scanf("%d",&pwm_duty_r);
	printf("PWM value [left]= ");
	s_val=scanf("%d",&pwm_duty_l);
	printf("PWM value [back]= ");
	s_val=scanf("%d",&pwm_duty_b);

	if(pwm_duty_l < 0) pwm_duty_l = 128 - pwm_duty_l;
	if(pwm_duty_r < 0) pwm_duty_r = 128 - pwm_duty_r;
	if(pwm_duty_b < 0) pwm_duty_b = 128 - pwm_duty_b;
	thread_create();
	encoder_create();

	//printf("thread_id=%d\n",(int)tasks[0]);
	printf("thread_id=%d\n",(int)task_id);
	//pthread_join(tasks[0],NULL);
	pthread_join(task_id,NULL);
	printf("Program stopped\n");

}


